import java.util.concurrent.*;
import java.util.*;   
   


public class SemaforTest 
{
    private static final int LOOP_COUNT = 100;		// 100 zkaznk
    private static final int MAX_AVAILABLE = 2;  	// dva prodavai
	private final static Semaphore semaphore = new Semaphore(MAX_AVAILABLE, true);   
	

	   
    private static class Pricer
	{				// uren ceny
		private static final Random random = new Random();  


	    public static int getGoodPrice() 
		{			//bu odhadcem
			int price = random.nextInt(100);

			try
			{
				Thread.sleep(50);					// urit cenu trv njak as
			}

			catch (InterruptedException ex) 
			{
				ex.printStackTrace();
			}

            return price;						// cena uren odhadcem
		}	// getGoodPrice()


		public static int getBadPrice()
		{
			return 100;						// nevhodn jednotn cena		
		}	// getBadPrice()


    }	// Pricer

   
	public static void main(String args[]) 
	{

		for (int i = 0; i < LOOP_COUNT; i++) 
		{       //vytvoen a sputn 100 vlken=zkaznik
			final int count = i;

			new Thread()
			{

				public void run() 
				{
					int price;

		            if (semaphore.tryAcquire()) 
					{		//prodava je voln, ur cenu
						
						try
						{
							price = Pricer.getGoodPrice();			
						}
						
						finally
						{
							semaphore.release();			//uvolnn prodavae
						}

					}	// if (semaphore.tryAcquire()) 
					
					else
					{					//prodava nen voln, pak nhradn reseni
						price = Pricer.getBadPrice();			
					}

					System.out.println(count + ": " + price);   //tisk .zkaznka a cena
				}	// run()

			}.start();

       }	// for (int i = 0; i < LOOP_COUNT; i++)

     }	// main()


}	// SemaforTest
