import java.util.*;
   import java.util.concurrent.*;   
   
   public class VymenikTest {   
   
     private static final int FULL = 10;	//delka bufferu
     private static final int COUNT = FULL * 12;//pocet dat je 120
     private static final Random random = new Random();
     private static volatile int sum = 0;
     private static Exchanger<List<Integer>> exchanger =   //predava se -
       new Exchanger<List<Integer>>();		//- seznam celych c.
     private static List<Integer> initiallyEmptyBuffer; //2 vymenovane -
     private static List<Integer> initiallyFullBuffer;	//- buffery
     private static CountDownLatch stopLatch =	//zavora s citacem 2
       new CountDownLatch(2);   
   
     private static class FillingLoop implements Runnable { //Producent
       public void run() {
         List<Integer> currentBuffer = initiallyEmptyBuffer;
         try {
           for (int i = 0; i < COUNT; i++) {
             if (currentBuffer == null)
               break; // stop na null
             Integer item = random.nextInt(100);
             System.out.println("Produkovano: " + item);
             currentBuffer.add(item);		//pridani do seznamu
             if (currentBuffer.size() == FULL)	//je-li plny volej-
               currentBuffer = 			//- exchange
                 exchanger.exchange(currentBuffer);
           }
         } catch (InterruptedException ex) {
           System.out.println("Vada exchange na strane producenta");
         }
         stopLatch.countDown();		//dekrementuje citac zavory
       }
     }   
   
     private static class EmptyingLoop implements Runnable {
       public void run() {
         List<Integer> currentBuffer = initiallyFullBuffer;
         try {
           for (int i = 0; i < COUNT; i++) {
             if (currentBuffer == null)
               break; // stop na null
             Integer item = currentBuffer.remove(0);
             System.out.println("Konzumovano " + item);
             sum += item.intValue();
             if (currentBuffer.isEmpty()) {
               currentBuffer = 
                  exchanger.exchange(currentBuffer);
             }
           }
         } catch (InterruptedException ex) {
           System.out.println("Vada exchange u konzumenta");
         }
         stopLatch.countDown();		//dekrementuje citac zavory
       }
     }   
   
     public static void main(String args[]) {
       initiallyEmptyBuffer = new ArrayList<Integer>();	//vytvor buffery
       initiallyFullBuffer = new ArrayList<Integer>(FULL);
       for (int i=0; i<FULL; i++) {		//naplneni bufferu
         initiallyFullBuffer.add(random.nextInt(100));
       }
       new Thread(new FillingLoop()).start();	//vytvor a spust producenta
       new Thread(new EmptyingLoop()).start();	//vytvor a spust konzumenta
       try {
         stopLatch.await();		//cekani na zavore
       } catch (InterruptedException ex) {
           ex.printStackTrace();
       }
       System.out.println("Soucet vsech polozek je " + sum);
     }
   }

