   import java.util.concurrent.*;   
   
   public class ZavoraTest {
     private static final int COUNT = 10;
     private static class Worker implements Runnable {//trida Worker ma dve zavory
       CountDownLatch startLatch;
       CountDownLatch stopLatch;
       String name;
       Worker(CountDownLatch startLatch,
           CountDownLatch stopLatch, String name) {
         this.startLatch = startLatch;
         this.stopLatch = stopLatch;
         this.name = name;
       }
       
       public void run() {	// Metoda run tridy Worker
         try {
           startLatch.await();	// tady se hned vlakna zastavi a pobezi az po **
         } catch (InterruptedException ex) {
           ex.printStackTrace();
         }
         System.out.println("Bezi: " + name);
         stopLatch.countDown();	//dekrementace citace zavory na konci vlakna
       }
    }       
       
    public static void main(String args[]) {
       CountDownLatch startSignal = new CountDownLatch(1);  //vytvoreni zavory s citacem
       CountDownLatch stopSignal  = new CountDownLatch(COUNT); //citac stopsignal je 10
       for (int i=0; i<COUNT; i++) {
         new Thread(
           new Worker(startSignal, stopSignal,	//vytvori 10vlaken a spusti je
             Integer.toString(i))).start(); 	//jmena vlaken je 0, 1, ..,9
       }
       System.out.println("Delej");	//Provede se po vytvoreni vsech 10 vlaken
       startSignal.countDown();		//startSignal zavora se vynuluje  **
       try {
         stopSignal.await();	//vlakno main ceka az vsech 10 vlaken skonci
       } catch (InterruptedException ex) {
           ex.printStackTrace();
       }
       System.out.println("Hotovo");
     }
   }

